#include "MAX31875_PlatformSpecific.h"
#include "MAX31875.h"
#include "stm32g0xx_hal.h"

extern I2C_HandleTypeDef hi2c2;

MAX31875_Status MAX31875_PlatformSpecific_Init() {
	return MAX31875_Status_Ok;
}

MAX31875_Status MAX31875_PlatformSpecific_Deinit() {
	return MAX31875_Status_Ok;
}

MAX31875_Status MAX31875_PlatformSpecific_Read(MAX31875_Device* dev, uint8_t registerAddress, uint8_t* buffer, size_t bufferSize) {
	HAL_StatusTypeDef status;

	status = HAL_I2C_Mem_Read(&hi2c2, dev->i2cAddress << 1, registerAddress, 1, buffer, bufferSize, 100);
	if (status) {
		return MAX31875_Status_I2CError;
	}

	return MAX31875_Status_Ok;
}

MAX31875_Status MAX31875_PlatformSpecific_Write(MAX31875_Device* dev, uint8_t registerAddress, uint8_t* buffer, size_t bufferSize) {
	HAL_StatusTypeDef status;

	status = HAL_I2C_Mem_Write(&hi2c2, dev->i2cAddress << 1, registerAddress, 1, buffer, bufferSize, 100);
	if (status) {
		return MAX31875_Status_I2CError;
	}

	return MAX31875_Status_Ok;
}
